package com.cultural.heritage.config;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.context.annotation.Configuration;

import java.io.Serial;
import java.io.Serializable;

/**
 * 微信小程序获取token响应体
 */
@Configuration
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class WxAccessToken implements Serializable {

    @Schema(description = "获取到的凭证")
    private String access_token;

    @Schema(description = "凭证有效时间，单位：秒。目前是7200秒之内的值。")
    private String expires_in;

    @Serial
    private static final long serialVersionUID = 1L;
}
