package com.cultural.heritage.model.dto.cart;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;

@Data
@Schema(description = "购物车记录添加请求体", requiredProperties = {"goodId", "quantity"})
public class CartRecordAddRequest implements Serializable {

    /**
     * 商品id
     */
    @Schema(description = "商品id(id > 0)", example = "20")
    private Long goodId;

    /**
     * 数量
     */
    @Schema(description = "商品数量(quantity > 0)", example = "3")
    private Integer quantity;


    @Serial
    private static final long serialVersionUID = 1L;
}
