package com.cultural.heritage.model.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 优惠券
 * @TableName   coupon
 */
@Data
@TableName("coupon")
public class Coupon implements Serializable {

    /**
     * 优惠券id
     */
    @TableId(type = IdType.AUTO)
    private Long id;


    /**
     * 优惠券名称
     */
    private String name;


    /**
     * 优惠内容
     */
    private String content;


    /**
     * 满减金额
     */
    private BigDecimal conditionAmount;


    /**
     * 标准金额
     */
    private BigDecimal standardAmount;


    /**
     * 需要的积分
     */
    private Integer requirePoints;


    /**
     * 有效开始日期
     */
    private String startTime;


    /**
     * 有效截止日期
     */
    private String endTime;


    /**
     * 使用说明
     */
    private String description;


    /**
     * 是否上架
     */
    private Integer isShelves;


    /**
     * 创建时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createTime;


    /**
     * 更新时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updateTime;


    /**
     * 优惠券状态
     */
    private String status;


    /**
     * 是否删除
     */
    private Integer isDelete;


    @Serial
    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
