package com.cultural.heritage.service.good;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import com.cultural.heritage.model.dto.good.GoodQueryRequest;
import com.cultural.heritage.model.entity.*;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

public interface GoodService extends IService<Good> {

    /**
     * 获取查询条件
     */
    QueryWrapper<Good> getGoodQueryWrapper(GoodQueryRequest goodQueryRequest, boolean isServiceGood);


    /**
     * 校验
     */
    void validGood(Good good, boolean update);


    /**
     * 更新常规类购物车中的小计
     */
    List<CartRecord> updateCartGoodPrice(Long goodId, BigDecimal targetPrice);


    /**
     * 更新服务类购物车中的小计
     */
    List<CartExperience> updateCartExperienceGoodPrice(Long goodId, BigDecimal targetPrice);



    /**
     * 判断商品是否存在或者下架
     */
    void checkGoodIsExist(Good good);


    /**
     * 判断常规类商品库存是否充足
     */
    void checkInventoryIsEnough(Integer neededQuantity, Integer actualQuantity);



    /**
     * 封装一个Map集合（键：BookingOrderQueryRequest.toString()，值：服务类商品待处理商品记录）
     */
    Map<String, PendingServiceGood> getPendingServiceGoodMap();



    /**
     * 校验购买的服务类商品预约情况是否合理
     */
    void checkServiceGoodBookingDetailIsProperly(Long goodId, String reservationDate, String timeSlot, Integer quantity);



    /**
     * 校验购买的服务类购物车中的商品预约情况是否合理
     */
    boolean checkServiceGoodCartBookingDetailIsProperly(Long goodId, String reservationDate, String timeSlot, Integer quantity, Map<String, PendingServiceGood> pendingServiceGoodMap, List<PendingServiceOrder> pendingServiceOrderList);


}
