package com.cultural.heritage.rabbitmq;

import com.rabbitmq.client.*;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeoutException;

@SpringBootTest
@RunWith(SpringRunner.class)
public class TestHeader {

    // 服务器IP
    private String host = "123.249.108.160";

    // RabbitMQ端口
    private int port = 5672;

    // 用户名
    private String username = "chenxinzhi";

    // 密码
    private String password = "yuanteng";

    // 虚拟机名字
    private String vhost = "vhost1";

    // 交换机名字
    private String exchangeName = "myExchange4";

    // 队列名字
    private String queueName1 = "myQueue1";


    // 连接对象
    private Connection connection;

    // 信道对象
    private Channel channel;


    public void setUp() throws IOException, TimeoutException {

        // 创建连接工厂、连接、信道
        ConnectionFactory factory = new ConnectionFactory();
        factory.setHost(host);
        factory.setPort(port);
        factory.setUsername(username);
        factory.setPassword(password);
        factory.setVirtualHost(vhost);
        // 连接
        connection = factory.newConnection();
        // 信道
        channel = connection.createChannel();
    }


    @Test
    public void testProducer() throws IOException, TimeoutException {
        setUp();
        // 创建交换机:直连交换机
        channel.exchangeDeclare(exchangeName, BuiltinExchangeType.HEADERS,
                true, false, null);
        // 创建队列
        channel.queueDeclare(queueName1, true, false, false, null);

        // 发送消息
        String msg = "Hello, RabbitMQ";
        Map map = new HashMap();
        map.put("one", "one2");
        map.put("two", "two");
        AMQP.BasicProperties props = new AMQP.BasicProperties().builder().headers(map).build();
         channel.basicPublish(exchangeName, "", props, msg.getBytes());
        // 关闭
        channel.close();
        connection.close();

    }


    @Test
    public void testConsumer() throws IOException, TimeoutException {
        setUp();
        // 获取消息
        DeliverCallback deliverCallback = (consumerTag, message) -> {
            String msg = new String(message.getBody());
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
        };
        CancelCallback cancelCallback = consumerTag -> {

        };
        // 绑定队列和交换机
        Map map = new HashMap();
        map.put("x-match", "any");
        map.put("one", "one");
        map.put("two", "two");
        channel.queueBind(queueName1, exchangeName, "", map);
        // 接收消息
        channel.basicConsume(queueName1, true, deliverCallback, cancelCallback);
    }


    @Test
    public void test() throws IOException, TimeoutException, InterruptedException {
        testProducer();
        Thread.sleep(5000);
        testConsumer();
    }


}
